<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import {
  SupportCopyMarkdown,
  SupportHero,
} from '~/components/support/index.vue';
import { getPageMetadata } from '~/common/meta';

import { getClient } from '~/plugins/contentful.js';

import { supportChildDataHelper } from '~/services/support/support-child-pages.service';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { LivePreviewMixin } from '~/mixins';

export default Vue.extend({
  components: {
    SupportHero,
    SupportCopyMarkdown,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin],
  async asyncData({ params }: any) {
    try {
      const supportSlug = `support/${params.support}`;
      const entries = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': supportSlug,
        include: 10,
      });

      const { pageContent } = entries.items[0].fields;
      const seoMetadata = entries.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const support = supportChildDataHelper(pageContent);
      return { support, metadata, items: entries.items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.support = supportChildDataHelper(
            updatedData[0].fields.pageContent,
          )),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <SlpContainer class="slp-mb-96">
    <SupportHero :data="support.supportHero" />
    <SlpSideNavigation :data="support.side_menu">
      <SupportCopyMarkdown
        v-for="(section, index) in support.components"
        :key="index"
        :data="section"
        :index="index"
      />
      <template #footer>
        <div>
          <SlpTypography
            v-show="support.side_menu.hyperlinks.text"
            tag="div"
            variant="body3-bold"
            class="nav-heading"
            >{{ support.side_menu.hyperlinks.text }}</SlpTypography
          >
          <SlpButton
            v-for="(button, buttonIndex) in support.side_menu.hyperlinks.data"
            :key="buttonIndex"
            class="hyperlinks"
            :variant="button.variant"
            :href="button.href"
            :data-ga-name="button.data_ga_name"
            :data-ga-location="button.data_ga_location"
            >{{ button.text }}
            <SlpIcon
              v-if="button.icon"
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
      </template>
    </SlpSideNavigation>
  </SlpContainer>
</template>

<style scoped>
* {
  font-display: swap;
}
</style>
